function un=p2interpol(xn,yn,u,x,y)
% P2INTERPOL: interpolate u to new mesh.
%
%  un=p2interpol(xn,yn,u,x,y)
%
% * u,x,y: defined on mesh x,y  
% * xn,yn: new mesh 
% * matlab interface, see octcomp/p2interpol for octave version 
%
% See also TriScatteredInterp
xv=reshape(x, size(x,1)*size(x,2), 1);
yv=reshape(y, size(y,1)*size(y,2), 1);
zv=reshape(u, size(u,1)*size(u,2), 1);
%F=TriScatteredInterp(xv,yv,zv);
F=scatteredInterpolant(xv,yv,zv);
un=F(xn,yn);
